SystemOrganization addCategory: #ConfigurationOfSton!

Object subclass: #ConfigurationOfSton
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSton'!

!ConfigurationOfSton commentStamp: '<historical>' prior: 0!
I am ConfigurationOfSton, a Metacello configuration to load the STON (Smalltalk Object Notation) project.
!

!ConfigurationOfSton class methodsFor: 'development support' stamp: 'SeanDeNigris 7/5/2012 19:06'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSton class methodsFor: 'private' stamp: 'SeanDeNigris 7/5/2012 19:06'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSton class methodsFor: 'private' stamp: 'SeanDeNigris 7/5/2012 19:06'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSton class methodsFor: 'private' stamp: 'SeanDeNigris 7/5/2012 19:06'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSton class methodsFor: 'metacello tool support' stamp: 'SeanDeNigris 7/5/2012 19:06'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSton class methodsFor: 'loading' stamp: 'SeanDeNigris 7/5/2012 19:06'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSton class methodsFor: 'loading' stamp: 'SeanDeNigris 7/5/2012 19:06'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSton class methodsFor: 'loading' stamp: 'SeanDeNigris 7/5/2012 19:06'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSton class methodsFor: 'accessing' stamp: 'SeanDeNigris 7/5/2012 19:06'!
project

	^self new project! !

!ConfigurationOfSton class methodsFor: 'development support' stamp: 'SeanDeNigris 7/5/2012 19:06'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSton methodsFor: 'baselines' stamp: 'SeanDeNigris 7/5/2012 19:11'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/STON'.
		spec
			package: 'Ston-Core';
			package: 'Ston-Tests' ].
! !

!ConfigurationOfSton methodsFor: 'baselines' stamp: 'SvenVanCaekenberghe 10/26/2012 10:45'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/STON'.
		spec
			package: 'STON-Core';
			package: 'STON-Tests' ].
! !

!ConfigurationOfSton methodsFor: 'accessing' stamp: 'SeanDeNigris 7/5/2012 19:06'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSton methodsFor: 'symbolic versions' stamp: 'SvenVanCaekenberghe 12/18/2012 10:29'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.4'.
! !

!ConfigurationOfSton methodsFor: 'versions' stamp: 'SeanDeNigris 7/5/2012 19:12'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: ''.
		spec author: 'SeanDeNigris'.
		spec timestamp: '7/5/2012 19:06'.
		spec
			package: 'Ston-Core' with: 'Ston-Core-SvenVanCaekenberghe.35';
			package: 'Ston-Tests' with: 'Ston-Tests-SvenVanCaekenberghe.33'. ].
! !

!ConfigurationOfSton methodsFor: 'versions' stamp: 'SvenVanCaekenberghe 10/25/2012 17:41'!
version02: spec
	<version: '0.2' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec
			package: 'Ston-Core' with: 'Ston-Core-SvenVanCaekenberghe.36';
			package: 'Ston-Tests' with: 'Ston-Tests-SvenVanCaekenberghe.34'. ].
! !

!ConfigurationOfSton methodsFor: 'versions' stamp: 'SvenVanCaekenberghe 10/26/2012 10:54'!
version03: spec
	<version: '0.3' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec
			package: 'STON-Core' with: 'STON-Core-SvenVanCaekenberghe.37';
			package: 'STON-Tests' with: 'STON-Tests-SvenVanCaekenberghe.29'. ]! !

!ConfigurationOfSton methodsFor: 'versions' stamp: 'SvenVanCaekenberghe 12/18/2012 10:29'!
version04: spec
	<version: '0.4' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec
			package: 'STON-Core' with: 'STON-Core-SvenVanCaekenberghe.42';
			package: 'STON-Tests' with: 'STON-Tests-SvenVanCaekenberghe.39'. ]! !
